unit uTest2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeEdit, ExtCtrls, TeeProcs, TeEngine, Chart, Series, CurvFitt,
  StdCtrls;

type
  TResTime = class(TForm)
    Chart1: TChart;
    ChartEditor1: TChartEditor;
    serLowerBound: TPointSeries;
    serUpperBound: TPointSeries;
    TTeeFunction1: TCurveFittingFunction;
    RtLabData: TPointSeries;
    serFit: TFastLineSeries;
    serSmoothFit: TFastLineSeries;
    LblRohms: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ResTime: TResTime;

implementation

uses math;

{$R *.dfm}


procedure PlotSmoothFit( serFit: tFastLineSeries;
                         serSmoothFit: tFastLineSeries;
                         FitFctn : TCurveFittingFunction;
                         smoothness : integer );

var interval, x, y : double; i, imax : integer; coeffs : array of double;

begin
  with FitFctn do begin
    imax := polydegree;
    SetLength( coeffs, imax );
    for i := 1 to imax do
      coeffs[ i-1 ] := AnswerVector[ i ];
    { end }
  end;
  with serFit do begin
    interval := ( maxXvalue - minXvalue )/ Smoothness;
    for i := 1 to Smoothness do begin
      x := minXvalue + (i-1) * interval;
      y := poly( x-minXvalue, coeffs ) + minYvalue;
      serSmoothFit.AddXY( x, y )
    end;
  end
end;

function FailureTime( ResOhms : single;
                      teeFunction: TCurveFittingFunction;
                      series : tFastLineSeries ) : single;

var t1, t2, dt, tmin, r, r1 , rmax, rmin : single;
  i, imax : integer;
  coeffs : array of double;

begin
  t2 := series.MaxXvalue;
  t1 := series.MinXvalue;
  tmin := t1;
  rmax := series.MaxYvalue;
  rmin := series.MinYvalue;
  dt := ( t2 - t1 ) / 200;
  with teeFunction do begin
    imax := polydegree;
    SetLength( coeffs, imax );
    for i := 1 to imax do
      coeffs[ i-1 ] := AnswerVector[ i ];
    { end }
  end;
  rmax := rmin + poly( 0, coeffs );
  rmin := rmin + poly( t2-tmin, coeffs );
  repeat
{
      x := minXvalue + (i-1) * interval;
      y := poly( x-minXvalue, coeffs ) + minYvalue;
 }
    repeat
      r := rmin + poly( t1-tmin, coeffs );
      t1 := t1 + dt;
    until r < ResOhms;
    t1 := t1 - dt;
    dt := dt/10;
  until abs( log10( r/ResOhms )) < 1.00E-04;
  Result := t1
end;

procedure TResTime.FormCreate(Sender: TObject);

var Rf, tf, rmax, rmin : single;

begin
  with RtLabData do begin
    AddXY( 5.005E+02, 5.86E+03 );
    AddXY( 6.665E+02, 4.00E+03 );
    AddXY( 8.366E+02, 2.98E+03 );
    AddXY( 9.530E+02, 2.62E+03 );
    AddXY( 1.325E+03, 1.79E+03 );
  end;
  tTeeFunction1.PolyDegree := 4;
  // tTeeFunction1.Factor := 4;
  PlotSmoothFit( serFit, serSmoothFit, tTeeFunction1, 500 );
  rmax := serFit.maxYvalue;
  rmin := serFit.minYvalue;
  rmax := serSmoothFit.maxYvalue;
  rmin := serSmoothFit.minYvalue;
  Rf := 3200;
  // tf := FailureTime( rf, TteeFunction1, serSmoothFit );
  LblRohms.Caption :=
    'Failure time: ' + FloatToStrf( tf, ffGeneral, 3, 4 ) +
    ' h.' + #13 + 'for ' +
    FloatToStrf( Rf, ffGeneral, 3, 4 ) +  ' ohms';
end;

procedure TResTime.Chart1DblClick(Sender: TObject);
begin
  ChartEditor1.Execute
end;

end.
